# VisiData documentation

* VisiData's [manpage](/man) contains a comprehensive overview of all global and sheet-specific commands.

* Our [system tests](/test) provide examples of how VisiData's atomic commands can be combined for complex workflows.

* Our [CONTRIBUTING.md](/contributing) contains information on how to contribute to VisiData's ongoing development and where we can be found for different types of support needs.

* We have some recordings of VisiData [demonstrations](/videos). More are in the works, but please let us know if there are any features in particular you wish to learn more about.

## For developers

VisiData's architecture is converging on an internal design and API, but it is not quite there. For this reason, we have decided not to release the developer documentation yet.  We will publish documentation on internals as components become interface complete.

However, if you wish to expand VisiData so that it can work with a new beloved data format, it is not difficult, and we would love to work with you and provide support and direction.

Currently, VisiData supports tsv, csv, hdf5, piping from stdin, json, mbtiles, postgres, shp, sqlite, xlsx, xls, and zip. We would love to find devs interested in creating loaders for xml, pandas dataframes, html, and many others. 
